=== debian/changelog ===
hipcub (5.7.1-3build1) noble; urgency=medium

  * No-change rebuild against librocprim-dev 5.7.1-2

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 23 Apr 2024 10:53:33 +0000

hipcub (5.7.1-3) unstable; urgency=medium

  * Migrate to unstable
  * d/rules: use rocprim arch conversion to ensure that the hipcub tests
    behave the same on all RDNA 2 hardware

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 26 Mar 2024 11:47:30 -0600

hipcub (5.7.1-3~exp1) experimental; urgency=medium

  * Enable gfx1100, gfx1101, and gfx1102 architectures
  * Update Build-Depends to require clang-17
  * Drop patchelf from Build-Depends
  * d/control: mark test packages as <!nocheck>

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 01 Mar 2024 11:37:31 -0700

hipcub (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 17 Feb 2024 22:44:01 -0700

hipcub (5.7.1-1) experimental; urgency=medium

  * New upstream version 5.7.1
  * Update upstream URLs
  * d/rules: drop gfx1011 from build architectures
  * d/rules: use compressed DWARF5 debug symbols

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 16 Feb 2024 18:55:44 -0700

hipcub (5.3.3-5) unstable; urgency=medium

  * Filter cf-protection hardening from device code.
    Fixes a FTBFS with dpkg >= 1.22 (Closes: #1052968)
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Tue, 26 Sep 2023 19:02:12 +0200
