## hipcub 6.1.2

=== debian/changelog ===
hipcub (6.1.2-1~exp1) experimental; urgency=medium

  * New upstream version 6.1.2
  * Set build-dep on librocprim-dev at >= 6.1
  * d/control: Add myself to Uploaders
  * d/control: Standards-Version 4.7.0

 -- Kari Pahula <kaol@debian.org>  Thu, 28 Nov 2024 07:32:58 +0200
