=== debian/control ===
--- 
+++ 
@@ -2,19 +2,20 @@
 Section: devel
 Homepage: https://github.com/ROCm/hipCUB
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/rocm-team/hipcub.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipcub
 Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
            Christian Kastner <ckk@debian.org>,
+           Kari Pahula <kaol@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                cmake,
                hipcc (>= 5.6.1~),
                libamd-comgr-dev (>= 6.0~),
                libhsa-runtime-dev (>= 5.7.1~),
                rocm-cmake,
-               librocprim-dev (>= 5.5.1~),
+               librocprim-dev (>= 6.1~),
                libgtest-dev <!nocheck>
 Rules-Requires-Root: no
