## hipcub 6.4.2

=== debian/changelog ===
hipcub (6.4.2-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.2.
  * Run wrap-and-sort.
  * debian/control: build-deps on librocprim-dev (>= 6.4.1~).
  * debian/copyright: added myself.
  * debian/copyright: update.
  * debian/control: build-deps on pkg-rocm-tools (>= 0.9.0~exp2).
  * debian/control: Added X-Rocm-Gpu-Architecture field.
  * debian/rules: adjust DAMDGPU_TARGETS option to use variable from rocm-
    target-arch.
  * debian/rules: append gencontrol with variable from rocm-target-arch.
  * Team upload.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Sat, 26 Jul 2025 08:13:56 +0200
